﻿using System;
using System.Drawing;
using System.IO;
using System.Windows.Forms;


namespace Test_EmulatorLCD
{
    public partial class Form1 : Form
    {
        LcdFont lcdFont = new LcdFont();
        public Form1()
        {
            InitializeComponent();
            MemoryStream _lcdfont = new MemoryStream(Properties.Resources.winstar);
            if (_lcdfont != null)
                lcdFont.ReadFromStream(_lcdfont);
            _lcdfont.Dispose();
        }

        private void Color_Panel_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(((Panel)sender).BackColor);
            e.Graphics.DrawRectangle(Pens.Black, e.ClipRectangle.X, e.ClipRectangle.Y, e.ClipRectangle.Width - 1, e.ClipRectangle.Height - 1);
        }

        private void numericUpDowns_ValueChanged(object sender, EventArgs e)
        {
            emulatorLCD1.RowCount = (byte)numericUpDown1.Value;
            emulatorLCD1.CharInRowCount = (byte)numericUpDown2.Value;
            textBox1_TextChanged(sender, e);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            emulatorLCD1.DotsContrast = (byte)trackBar1.Value;
        }

        private void panel_color_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ((Panel)sender).BackColor = colorDialog1.Color;
                if (((Panel)sender).Name == "fon")
                    emulatorLCD1.BackgroundColor = colorDialog1.Color;
                else
                    emulatorLCD1.DotsColor = colorDialog1.Color;
            }
            textBox1_TextChanged(sender, e);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            Point cur = new Point(-1);
            emulatorLCD1.ddram.Clear();
            if (textBox1.Text.Length > 0)
                for (int y = 0; y < emulatorLCD1.RowCount; y++)
                    if (y < textBox1.Lines.Length)
                        for (int x = 0; x < emulatorLCD1.CharInRowCount; x++)
                            if (x < textBox1.Lines[y].Length)
                            {
                                foreach (LcdChar lcdChar in lcdFont.Chars)
                                    if (lcdChar.Symbol == textBox1.Lines[y][x])
                                    {
                                        emulatorLCD1.ddram.dots[y, x] = lcdChar.GetDots();
                                        emulatorLCD1.Invalidate();
                                        cur.X = x + 1;
                                        cur.Y = y;
                                        break;
                                    }
                            }
                            else
                                break;                                             
                    else
                        break;
            emulatorLCD1.Cursor_LCD_Coordinate = cur;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            checkBox2.Enabled = checkBox1.Checked;
            emulatorLCD1.Cursor_LCD = checkBox1.Checked ? checkBox2.Checked ? EmulatorLCD.EmulatorLCD.cursor_LCD.Blink : EmulatorLCD.EmulatorLCD.cursor_LCD.Line : EmulatorLCD.EmulatorLCD.cursor_LCD.None;
        }
    }
}
